main()
{
	deepwaters = getentarray("deepwater", "targetname");
	if (deepwaters.size > 0)
	{
		level._effect["deepwater_player"] = loadfx ("fx/water/impact_playerjump_water.efx");
		level._effect["water_hit"] = loadfx ("fx/explosions/waterhit_veh.efx");
		level._effect["water_hitafter"] = loadfx ("fx/explosions/grenade_water.efx");
	}
	
	for(i = 0; i < deepwaters.size; i++)
	{
		deepwaters[i] thread deepwater_think();
	}	

	hipwaters = getentarray("hipwater", "targetname");
	for(i = 0; i < hipwaters.size; i++)
	{
		hipwaters[i] thread hipwater_think();
	}	

}

deepwater_think()
{
	while (1)
	{
		self waittill ("trigger",other);		

		if ( isPlayer(other) )
		{
			if (other isinvehicle())
			{	
				other thread deepwater_kill_vehicle(self); 
			}
			else
			{	
				other thread deepwater_shock(self);
			}
		}
		else
		{
			other thread deepwater_kill_vehicle(self);
		}
	}
}

deepwater_kill_vehicle(trigger)
{
	if(isDefined(self.indeepwater))
		return;
		
	self.indeepwater = true;
	origin = self getorigin();
	self playSound ("shell_incoming", origin);
	
	wait 1;

	playfx ( level._effect["water_hitafter"], (origin + (30,10,0)));
	self playSound("waterhit", origin);
	
	wait(.5);
	wait(randomFloat(.5));
	
	if(self istouching(trigger))
	{
		origin = self getorigin();
		org = self.origin;
		range = 50;
		maxdamage = 4000;
		mindamage = 400;

		playfxontag( level._effect["water_hit"], self, "tag_origin" );

		//self dodamagemod (maxdamage, origin, "MOD_EXPLOSIVE");
		//radiusDamage(origin, range, maxdamage, mindamage, attacker, inflictor, mod);
		//radiusDamage(org, range, 10000, 9000, 0, "Feldwebel Daffy", "MOD_EXPLOSIVE");
		radiusDamage(org, range, maxdamage, mindamage);

		level thread playSoundinSpace ("waterhit", org);

	}
	
	self.indeepwater = undefined;
}

deepwater_shock(trigger)
{
	if(isDefined(self.deepwater) || !isAlive(self) )
	{
		return;
	}
		
	self.deepwater = true;
	self playsound ("land_water");

	wait(.5);
	wait(randomFloat(.5));

	if(self istouching(trigger))
	{
		origin = self getorigin();
		org = self.origin;
		strShocktype = "melee"; //or default_mp
		duration = 5;

		playfx ( level._effect["deepwater_player"], (origin + (0,0,60)));

		if(isalive(self))
		{
			wait 0.15;
			self viewkick(10, self.origin);  //Amount should be in the range 0-127, and is normalized "damage".  No damage is done.
			self shellshock(strShocktype, duration);
			self dodamagemod (5, origin, "MOD_WATER");
		}

		playfx ( level._effect["deepwater_player"], (origin + (0,0,60)));

		wait 2;
	}
	self.deepwater = undefined;
}

hipwater_think()
{
	while (1)
	{
		self waittill ("trigger",other);		

		if ( isPlayer(other) )
		{
			if (other isinvehicle())
			{
				continue;
			}
			else
			{	
				other thread hipwater_stance(self);
			}
		}
		else
		{
			continue;
		}
	}
}

hipwater_stance(trigger)
{
	if(self istouching(trigger))
	{
		self setClientCvar("cl_stance", 0);
	}
	wait 0.5;
}

playSoundinSpace (alias, origin)
{
	org = spawn ("script_model",origin);
	wait 0.05;
	org playsound (alias);
	wait 6;
	org delete();
}